summaryrefslogtreecommitdiff
path: root/tests/fmt/goal-option
diff options
context:
space:
mode:
authorBruce Korb <bkorb@gnu.org>2012-04-05 17:13:14 -0700
committerJim Meyering <meyering@redhat.com>2012-04-12 22:46:51 +0200
commit0092d5d88bb620885b88aa8b49b079b04066583f (patch)
treef16aeb4d08428b60f19e55ec2f3c398fd9554995 /tests/fmt/goal-option
parent3d53e7fe1c31aa440cc9708c7c51db6b78c07653 (diff)
downloadcoreutils-0092d5d88bb620885b88aa8b49b079b04066583f.tar.xz
fmt: accept new --goal=WIDTH (-g) option
Accept -g for BSD/Plan9 compatibility. * NEWS (New features): Mention it. * tests/fmt/goal-option: New test. * tests/fmt/long-line: Rename from tests/fmt-long-line. * tests/fmt/base: Rename from tests/misc/fmt. * doc/coreutils.texi: Document it. * src/fmt.c (main): Accept the new option (check_for_goals): new function to implement the operands Based on BSD's and Plan-9's fmt programs.
Diffstat (limited to 'tests/fmt/goal-option')
-rwxr-xr-xtests/fmt/goal-option56
1 files changed, 56 insertions, 0 deletions
diff --git a/tests/fmt/goal-option b/tests/fmt/goal-option
new file mode 100755
index 000000000..2efb8c5ce
--- /dev/null
+++ b/tests/fmt/goal-option
@@ -0,0 +1,56 @@
+#!/bin/sh
+# Exercise the fmt -g option.
+
+# Copyright (C) 2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ fmt
+
+cat <<\_EOF_ > base || fail=1
+
+@command{fmt} prefers breaking lines at the end of a sentence, and tries to
+avoid line breaks after the first word of a sentence or before the last word
+of a sentence. A @dfn{sentence break} is defined as either the end of a
+paragraph or a word ending in any of @samp{.?!}, followed by two spaces or end
+of line, ignoring any intervening parentheses or quotes. Like @TeX{},
+@command{fmt} reads entire ''paragraphs'' before choosing line breaks; the
+algorithm is a variant of that given by
+Donald E. Knuth and Michael F. Plass
+in ''Breaking Paragraphs Into Lines'',
+@cite{Software---Practice & Experience}
+@b{11}, 11 (November 1981), 1119--1184.
+_EOF_
+
+fmt -g 60 -w 72 base > out || fail=1
+
+cat <<\_EOF_ > exp
+
+@command{fmt} prefers breaking lines at the end of a sentence,
+and tries to avoid line breaks after the first word of a sentence
+or before the last word of a sentence. A @dfn{sentence break}
+is defined as either the end of a paragraph or a word ending
+in any of @samp{.?!}, followed by two spaces or end of line,
+ignoring any intervening parentheses or quotes. Like @TeX{},
+@command{fmt} reads entire ''paragraphs'' before choosing line
+breaks; the algorithm is a variant of that given by Donald
+E. Knuth and Michael F. Plass in ''Breaking Paragraphs Into
+Lines'', @cite{Software---Practice & Experience} @b{11}, 11
+(November 1981), 1119--1184.
+_EOF_
+
+compare exp out || fail=1
+
+Exit $fail